<?php
class AttendanceConfController extends AppController
{   
	var $helpers = array('Html','Xml');
	var $uses=array('Poll','Group', 'Host','Configure', 'Validation','License','User',
		'Employee','Employeeaccount','Timecontrol','Workstatus','Grpattendconf','Hstattendance', 'Agentversion', 'Rlthstgrp','Mailaddress','Activedirectory');
	var $components = array("GenerateFiles");
	var $layout='attendance';
		
	function beforeFilter()
	{

	}
	
	function index($errorMessage = null)
	{
		$this->set("manage", $this->requestAction("/attendance_conf/manage", array("return"))) ;
    	$this->layout = "system";
    	$this->pageTitle = __('title',$return = true);  
	}
	
	function manage($depand=null,$tag=null){
        $errorMessage=array();
        $this->layout='ajax';
        $data= array();
		
        if($depand=='2'){//項目名変更
			var_dump($this->data);
			foreach($this->data['Workstatus'] as $s){
				
				echo $s;
			}
			$newname = eregi_replace("　", " ", $this->data['Workstatus']['content_'.$tag]);
            $newname = trim($newname, " ");
            if($this->Validation->maxLength($newname,200)){
                $updateaddition=Array(
                'Workstatus' => Array(
                'id' => $tag,
                'name' => $newname,
                )
                );
                $this->Workstatus->save($updateaddition);
				$this->Hstattendance->updateAll( array("1=1"), array('Hstattendance.newconf' => 1));

            }
            else{
                $errorMessage=array();
                if(!$this->Validation->maxLength($this->data['Workstatus']['content_'.$tag],200)){
                    if(@ !in_array('E-00300',$errorMessage['computer_list']))
                    $errorMessage['computer_list'][] = 'E-00300';
                }
            }
			$data= $this->Workstatus->findAll();
			
        }
		else if($depand=='4'){
            if($this->data['Grpattendconf']['notification']!="" 
				&& $this->Validation->numeric($this->data['Grpattendconf']['notification'])
				&& $this->data['Grpattendconf']['threshold']!="" 
				&& $this->Validation->numeric($this->data['Grpattendconf']['threshold']) )
			{
                $set_update=Array(
                'Grpattendconf' => Array(
                'id' => 1,
				'group_id' => 1,
                'notification' => $this->data['Grpattendconf']['notification'],
				'threshold' => $this->data['Grpattendconf']['threshold'],
                )
                );
                $this->Grpattendconf->save($set_update);
            }
            else{
                $errorMessage=array();
                if($this->data['Grpattendconf']['notification']=="" || $this->data['Grpattendconf']['threshold']==""){
                    if(@ !in_array('E-00100',$errorMessage['alert_depand']))
                    $errorMessage['alert_depand'][] = 'E-00100';
                }
                else if(!$this->Validation->numeric($this->data['Grpattendconf']['notification']) || !$this->Validation->numeric($this->data['Grpattendconf']['threshold'])){
                    if(@ !in_array('E-00600',$errorMessage['alert_depand']))
                    $errorMessage['alert_depand'][] = 'E-00600';
                }
            }
        }else
			$data= $this->Workstatus->findAll();


//var_dump($data);
        //$data= $this->Workstatus->findAll();
		$set= $this->Grpattendconf->find("Grpattendconf.id=1");//var_dump($set);
        $this->set('set', $set);
        $this->set('data', $data);
        $this->set('errorMessage', $errorMessage);
    }
	
	function addhost($name){
		//アカウントの設定
		$user = null;
		$pwd = null;
		$ad = $this->Activedirectory->find(null,null,null,'1',null);
		if(!empty($ad)){
			$user = $this->Lv->spec_char_dbm($ad['Activedirectory']['adminuser']);
			$pwd = $ad['Activedirectory']['password'];
		}
		//PS
		$poll_id = 0;
		$poll_type = 0;
		$status = 2;
		$poll = $this->Poll->find('Poll.id != 0', null,'Poll.id DESC','1',null);
		if(!empty($poll)){
			$poll_id = $poll['Poll']['id'];
			$poll_type = 1;
			$status = 0;
		}
		
		//管理対象PCの登録
		$regist = date('Y-m-d H:i:s',time());
		$allupdatedate = Array('Host' => Array(
								'host_name' => $this->Lv->spec_char_dbm($name),
								'access_name' => $this->Lv->spec_char_dbm($name),
								'poll_id' => $poll_id,
								'poll_type' => $poll_type,
								'status' => $status,
								//'isagent' => 1,
								'username' => $user,
								'password' => $pwd,
								'regist_time' => $regist),
								);
		
		$this->Host->save($allupdatedate);
		$criteria[] = "Host.regist_time = '".$regist."'";
		$criteria[] = "Host.host_name = '".$this->Lv->spec_char_dbm($name)."'";
		$data= $this->Host->find($criteria);
		$addgroupdate=Array(
				'Rlthstgrp' => Array(
				'host_id' => $data['Host']['id'],
				'group_id' => 1,
				)
				);
		$this->Rlthstgrp->save($addgroupdate);

		return $data['Host']['id'];
	}
	
	//従業員マスターの自動登録
	function checkemployee($host, $account)
	{
		$asso = array(
			'Employeeaccount : employeeaccounts : LEFT' => array('Employeeaccount.employee_id = Employee.id'),
			'Host : hosts' => array('Employeeaccount.host_id = Host.id')
		) ;
			
		//取得項目
		$fields = array(
			'Host.id',
			'Host.host_name',
			'Employeeaccount.account',
			'Employee.id_name',
		);
		$criteria = array("1=1");
		$emps = $this->Employee->findByAsso($criteria, $fields, null, null, null, $asso);
		//var_dump($emps);
		$mail = false;
		$mail_acc = "";
		$mail_emp = "";
		$regist = false;
		$accountcount = 0;
		$updhost = false;
		$hostid = null;
		if(isset($emps[0])){
			foreach($emps as $emp){
				if(strcasecmp($emp['Employeeaccount']['account'], $account) == 0)
				{
					$accountcount++;
					if(strcasecmp($emp['Host']['host_name'], $host) == 0)
					{
						//何もしない
						$hostid = $emp['Host']['id'];
					}else{
						//コンピュータ名を更新
						$hostid = $emp['Host']['id'];
						$updhost = true;
					}
				}else{ 
					if(strcasecmp($emp['Host']['host_name'], $host) == 0)
					{
						//メール通知
						$mail = true;
						$mail_acc = $emp['Employeeaccount']['account'];
						$mail_emp = $emp['Employee']['id_name'];
					}else{
						//ダミーで登録
						$regist = true;
					}
				}
			}
		}
		if($accountcount == 1){
			if($updhost){
				//コンピュータ名を更新
				$set_update=Array(
					'Host' => Array(
						'id' => $hostid,
						'host_name' => $this->Lv->spec_char_dbm($host),
						'access_name' => $this->Lv->spec_char_dbm($host)
					)
				);
				$this->Host->save($set_update);
				return $hostid;
			}else{
				//何もしない
				return $hostid;
			}
		}else if($mail){
			//メール通知
			$txt = sprintf("既に同一のコンピュータ名の従業員マスター登録があります。\\n従業員番号： %s, コンピュータ名： %s\\n\\n登録済みアカウント名： %s\\nアカウント名： %s", $mail_emp, $host, $mail_acc, $account);
			$this->mailsend("従業員マスター通知", $txt);
			return $hostid;
		}else if($regist && is_null($hostid)){
			//ダミーで登録
			$upddate = date("Y/m/d H:i:s");
			$hostdata = $this->Host->findByHostName($this->Lv->spec_char_dbm($host));
			if(!empty($hostdata))
				$hostid = $hostdata['Host']['id'];
			else
				$hostid = $this->addhost($host);
			$id_name = "DUMMY_".$host;
			$name = "";
			
			$newEmployee = array();
			$newEmployee = array(
				'Employee' => array(
						'id_name' => $this->Lv->spec_char_dbm($id_name),
						'name' => $this->Lv->spec_char_dbm($name),
						'group_id' => 1,
						'status' => 0,
						'enabled' => 0,
						'name_eng' => null,
						'linenumber' => null,
						'update_time' => $upddate,
						'update_user' => "autoregist"
					)
				); 		
			$newEmployee['Employee']['id'] = null;
			$newEmployee['Employee']['regist_user'] = "autoregist";
			
			$this->Employee->save($newEmployee);
			
			$cr = array("id_name = '".$this->Lv->spec_char_dbm($id_name)."'",
						"update_time = '".$upddate."'");
			$tmp = array();
			$tmp = $this->Employee->find($cr);
			$newid = $tmp['Employee']['id'];	
				
			$newAccount = array(
					'Employeeaccount' => array(
						'number' => 0,
						'employee_id' => $newid,
						'host_id' => $hostid,
						'account' => $this->Lv->spec_char_dbm($account),
						'exist' => 2
					)
				); 
			$this->Employeeaccount->save($newAccount);
			return $hostid;
		}else{
			//何もしない
			return $hostid;
		}
		
	}
	
	//エージェントから通知
	function status($hostid = null, $status = null, $hostname = null, $account = null)
    {	
		$this->layout="ajax";
		if($hostid == 0 && !is_null($hostname))
		{
			if(is_null($account)){
				$host = $this->Host->findByHostName($this->Lv->spec_char_dbm($hostname));
				if(!empty($host))
					$hostid = $host['Host']['id'];
			}else{
				$hostid = $this->checkemployee($hostname, $account);
			}
		}
		if($hostid == 0 && !is_null($hostname)){//登録
			if(is_null($account))
				$hostid = $this->addhost($hostname);
		}
		
		if(is_null($hostid) || is_null($status))
			echo "-1";
		elseif(!$this->Validation->numeric($hostid) || !$this->Validation->numeric($status) ){
			echo "-2";
		}
		else{
			$data = $this->Hstattendance->find(
				array("Hstattendance.host_id" => $this->Lv->spec_char_dbm($hostid),
						"Hstattendance.status" => $this->Lv->spec_char_dbm($status)));
			
			$set_update=Array(
                'Hstattendance' => Array(
                'host_id' => $hostid,
				'status' => $status,
                )
                );
			if(empty($data))
				$set_update['Hstattendance']['lasttime'] = "'".date("Y/m/d H:i:s")."'";
            $this->Hstattendance->save($set_update);
			echo "1";
		}
	}
	
	function check($hostid = null, $hostname = null)
    {	
		$this->layout="ajax";
		if($hostid == 0 && !is_null($hostname))
		{
			$host = $this->Host->findByHostName($this->Lv->spec_char_dbm($hostname));
			$hostid = $host['Host']['id'];
		}
		
		if(is_null($hostid))
			echo "0";
		else{
			$data = $this->Hstattendance->find(array("Hstattendance.host_id" => $this->Lv->spec_char_dbm($hostid)), "newconf");
			//var_dump($data);
			
			if(empty($data))
				echo "1";
			else{
				//現在の時刻を記録し、死活監視に利用する
				$set_update=Array(
					'Hstattendance' => Array(
						'host_id' => $hostid,
						'heartbeat' => date("Y/m/d H:i:s")
					)
				);
				$this->Hstattendance->save($set_update);
			
				echo $data['Hstattendance']['newconf'];
			}
		}
	}
	
	function getTimecontrol($groupid)
	{
		$default = $this->Timecontrol->find(array("group_id" => $groupid));
		if(empty($default))
		{
			$parent = $this->Group->group_father_id($groupid);
			if(!empty($parent))
				$default = $this->getTimecontrol($parent);
		}
		return $default;
	}
	//ステータスの一覧などの設定取得
    function get($hostid = null, $hostname = null)
    {	
		$this->layout="ajax";
		if($hostid == 0 && !is_null($hostname))
		{
			$host = $this->Host->findByHostName($this->Lv->spec_char_dbm($hostname));
			$hostid = $host['Host']['id'];
		}
		
		$criteria = array();
		$criteria[] = "1=1";
		$fields = array(
			'Workstatus.id',
			'Workstatus.autoreset',
			'Workstatus.name');

		$data = $this->Workstatus->findAll($criteria, $fields, "showorder asc");
		
		$set= $this->Grpattendconf->findAll("Grpattendconf.id=1", array("Grpattendconf.threshold","Grpattendconf.cycle"));
		
		////////////
		$asso = array(
			'Employeeaccount : employeeaccounts : LEFT' => array('Employeeaccount.employee_id = Employee.id'),
		) ;
			
		//取得項目
		$fields = array(
			'Employee.group_id'
		);
		$criteria = array();
		$criteria[]="Employeeaccount.host_id = ".$hostid;
		$empgrp = $this->Employee->findByAsso($criteria, $fields, null, null, null, $asso);
		//var_dump($timectrl);
		if(isset($empgrp[0])){
			$tmp = $this->getTimecontrol($empgrp[0]['Employee']['group_id']);
			$timectrl['Timecontrol']['start_day'] = $tmp['Timecontrol']['start_day'].":00";
		}else
			$timectrl['Timecontrol']['start_day'] = "00:00:00";
		
		
		$this->Hstattendance->updateAll( array("Hstattendance.host_id = $hostid"), array('Hstattendance.newconf' => 0));

		header("Content-Type: application/xml; charset=utf-8");
		$this->set(compact('data'));
		$this->set(compact('set'));
		$this->set(compact('timectrl'));
    }
	
	
	
	function installlog($host, $account)
	{
		//$this->layout='ajax';
		set_time_limit(0);

		if(is_null($host) || is_null($account))
			exit;
		
		$form_data = sprintf("%s,%s,%s\r\n", date("Y/m/d H:i:s"), $host, $account);
		$tmp =str_replace("\\","/", RESTORE_FILE_PATH);
		$file = $tmp . "/../Installlogs.txt";
		if(!file_exists($logdir)){

		}
		$txt = fopen($file,'a'); 
		if(!$txt)
			exit;
		flock($txt, LOCK_EX);
		fwrite($txt,$form_data); 
		fclose($txt); 
		
		$txt = sprintf("在席管理エージェントがインストールされました。(コンピュータ名： %s, アカウント名： %s)", $host, $account);
		if($this->mailsend("エージェントインストール完了通知", $txt))
			echo 1;
		else
			echo 1;
		exit;
	}
	
	//バージョン情報を通知
    function version($hostid,$version,$hostname=null)
    {
		$this->layout="ajax";
		if($hostid == 0 && !is_null($hostname))
		{
			$host = $this->Host->findByHostName($this->Lv->spec_char_dbm($hostname));
			$hostid = $host['Host']['id'];
		}
		
		if(is_null($hostid))
			echo "-1";
		else if(!$this->Validation->numeric($hostid)){
			echo "-2";
		}
			
		$agent = array(
		'Agentversion' => array(
				'host_id' => $hostid,
				'lasttime' => date("Y/m/d H:i:s"),
				'version' => $version
			)
		);
		$this->Agentversion->save($agent);			
		
		echo "ok";
		exit;
    }
	
	function set_str_encoding($name)
    {
        $result= mb_convert_encoding($name,"SJIS-win","UTF-8"); 
        return $result;
    } 
	function mailsend($title, $body){
		$this->autoRender = false; // Viewを使わないように
		
		$result_alt=$this->Mailaddress->findAll();
		if(!empty($result_alt))
		{
			foreach ($result_alt as $key => $value)
			{
				if($key==count($result_alt)-1){
					$mails_address=$mails_address.$value['Mailaddress']['mails_address'];
				}else{
					$mails_address=$mails_address.$value['Mailaddress']['mails_address'].";";
				}
				$smtp_server = $value['Mailaddress']['smtp_server'];
				$smtp_port = $value['Mailaddress']['smtp_port'];
				$mail_address = $value['Mailaddress']['mail_address'];
				
				$smtp_check = $value['Mailaddress']['smtp_check'];
				$smtp_user = $value['Mailaddress']['smtp_user'];
				$smtp_password = $this->Lv->save_decode($value['Mailaddress']['smtp_password']);
				//$rsmtp_password = $value['Mailaddress']['smtp_password'];
	
				$pop_check = $value['Mailaddress']['pop_check'];
				$pop = $value['Mailaddress']['pop'];
				$pop_port = $value['Mailaddress']['pop_port'];
				$pop_user = $value['Mailaddress']['pop_user'];
				$pop_password = $this->Lv->save_decode($value['Mailaddress']['pop_password']);
				//$rpop_password = $value['Mailaddress']['pop_password'];
				$smtp_ssl = $value['Mailaddress']['smtp_ssl'];
			}
			
			//設定ファイル内容
			$contents = "";
			$contents .= "[Config]\r\n";
			$contents .= "Address=".$mails_address;
			$contents .= "\r\n";
			$contents .= "FromAddress=".$mail_address;
			$contents .= "\r\n";
			$contents .= "SMTPServer=".$smtp_server;
			$contents .= "\r\n";
			$contents .= "SMTPUser=".$smtp_user;
			$contents .= "\r\n";
			$contents .= "SMTPPassword=".$smtp_password;
			$contents .= "\r\n";
			$contents .= "SMTPAuth=".$smtp_check;
			$contents .= "\r\n";
			$contents .= "SMTPPort=".$smtp_port;
			$contents .= "\r\n";
			$contents .= "SMTPSSL=".$smtp_ssl;
			$contents .= "\r\n";
			$contents .= "POPServer=".$pop;
			$contents .= "\r\n";
			$contents .= "POPUser=".$pop_user;
			$contents .= "\r\n";
			$contents .= "POPPassword=".$pop_password;
			$contents .= "\r\n";
			$contents .= "POPBeforeSMTPFlag=".$pop_check;
			$contents .= "\r\n";
			$contents .= "POPPort=".$pop_port;
			$contents .= "\r\n";
			
			$contents .= "Title=".$title;
			$contents .= "\r\n";
			$contents .= "Body=".$body;
			$contents .= "\r\n";
			
	
			//一時ファイル作成　BEGIN
			$filename = "mail".substr(md5(time().rand(0,1000000)),0,10) . ".ini";
			$csv_folder=ROOT.DS.APP_DIR.DS."tmp".DS."csv".DS;
			$file = $csv_folder.$filename;
			$fp = fopen($file, 'w');  

			$enc= $this->set_str_encoding($contents);
			fputs($fp, $enc);
			
			fclose($fp);
	
			//exe実行
			$v_path=(VENDORS);
			$tmpfname = "MailTest.exe";//sprintf("%sMailTest.exe", $v_path);
			$wd = getcwd();
			chdir($v_path);

			$result = exec( sprintf("%s \"%s\"", $tmpfname, $file), $output, $return_var);

			//一時ファイル削除
		//	unlink($file);
			chdir($wd);
			if($return_var == "0")
				return true;
			else
				return false;
		}
		//echo 4;
		return false;
	}
}
?>